/* $Id: DumpDsnSubset.c,v 1.1 1998/01/26 06:25:38 rgr Exp $ */

/* $RCSfile: DumpDsnSubset.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/26 06:25:38 $ */
/* $Revision: 1.1 $ */

#include <sys/types.h>
#include <stdio.h>

void DumpDsnSubset(DsnSubset *subset)
{
   int date;
   int time;
   int second1970;
   int yr;
   int mon;
   int day;
   int hr;
   int min;
   int sec;
   int csec;
   int i;

   date = 10000*( ((u_int)subset->year) % 100) + 101;
   second1970 = ConvertToSeconds1970(date, 0) + 
                86400*((u_int) subset->DayOfYear - 1) +
                subset->TimeOfDay/100;
   ConvertFromSeconds1970(second1970, &date, &time);
   yr = date/10000;
   mon = (date/100) % 100;
   day = date % 100;
   hr = time/10000;
   min = (time/100) % 100;
   sec = time % 100;
   csec = subset->TimeOfDay % 100;
   printf("DSN SUBSET - ");
   printf("%2.2d/%2.2d/%2.2d %2.2d:%2.2d:%2.2d.%2.2d", yr, mon, day,
                                                   hr, min, sec, csec); 
   printf("     %d Packet", subset->PacketSecondaryHeader);
   printf("     %d Spacecraft ID\n", subset->SpacecraftId);
   printf("%2.2d.%2.2d %d Facility & Assembly", subset->facility,
                                                subset->subfacility,
                                                subset->assembly);
   printf("     %d Data Nature", subset->DataNature);
   printf("     %d Virtual Channel ID\n", subset->VirtualChannelId);
   printf("%d Major Frame Count", subset->MajorFrameCount);
   printf("    %d Minor Frame Count", subset->MinorFrameCount);
   printf("    %4.4x Error Flags", subset->ErrorFlags);
   printf("    %d Format Id\n", subset->FormatId);
   printf("%d CRIS Internal Temperature",
                                     subset->CrisInternalTemperature1);
   printf("    %d CRIS Internal Temperature 2\n",
                                     subset->CrisInternalTemperature2);
   printf("%d SIS Internal Temperature",
                                      subset->SisInternalTemperature1);
   printf("    %d SIS Internal Temperature 2\n",
                                      subset->SisInternalTemperature2);
   printf("%d CRIS Current", subset->CrisCurrent);
   printf("     %d SIS Current", subset->SisCurrent);
   printf("     %d SIS Cover Telltale\n", subset->SisCoverTelltale);

   printf("CRIS Data   ");
   for (i=0; i<SIZE_CRIS_MINOR_FRAME; i++)
   {
      if (!(i % 4)) printf(" ");
      if (!(i % 32)) printf("\n   ");
      printf("%2.2x", subset->CrisData[i]);
   }
   printf("\nSIS Data   ");
   for (i=0; i<SIZE_SIS_MINOR_FRAME; i++)
   {
      if (!(i % 4)) printf(" ");
      if (!(i % 32)) printf("\n   ");
      printf("%2.2x", subset->SisData[i]);
   }
   printf("\n");
}
