/* $Id: DumpHeaderAggregation.c,v 1.1 1998/01/26 06:25:49 rgr Exp $ */

/* $RCSfile: DumpHeaderAggregation.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/26 06:25:49 $ */
/* $Revision: 1.1 $ */

#include <sys/types.h>
#include <stdio.h>
#include "downlink/UnpackedHeaderAggregation.h"
#include "AceTime.h"

#include "UnpackHeaderAggregation.h"
#include "ace/cvtFromSec1996.h"
#include "ace/cvtToSec1996_yd_0.h"

void DumpHeaderAggregation(u_char *HeaderAggregation)
{
                      double day;
   UnpackedHeaderAggregation header;
                         int msec;
                         int sec;
                      u_long Second1996;
              struct AceTime time;

   UnpackHeaderAggregation(HeaderAggregation, &header);
   printf("HEADER AGGREGATION LABEL - %d Type Attribute",
                                                 header.TypeAttribute);
   printf("     %d Length Attribute\n", header.LengthAttribute);
   printf("PRIMARY HEADER - %d Type", header.primary.TypeAttribute);
   printf("    %d Length", header.primary.LengthAttribute);
   printf("    %d Major Data Class", header.primary.MajorDataClass);
   printf("    %d Minor Data Class\n", header.primary.MinorDataClass);
   
   day = (double) (header.secondary.EarthReceivedTime.day - (13879-1));
   sec = header.secondary.EarthReceivedTime.milliseconds / 1000;
   msec = header.secondary.EarthReceivedTime.milliseconds % 1000;
   Second1996 = cvtToSec1996_yd_0(1996L, day + ((double) sec)/86400.0);
   time = cvtFromSec1996(Second1996);
   printf("SECONDARY HEADER - ");
   printf("%2.2ld/%2.2ld/%2.2ld %2.2ld:%2.2ld:%2.2ld.%3.3d", time.year,
            time.month, time.day, time.hour, time.min, time.sec, msec);
   printf("   %u Record Sequence Number\n",
                                header.secondary.RecordSequenceNumber);
   printf("%d Type", header.secondary.TypeAttribute);
   printf("     %d Length", header.secondary.LengthAttribute);
   printf("     %d Originator ID", header.secondary.OriginatorId);
   printf("     %d Last Modifier ID\n",
                                      header.secondary.LastModifierId);
   printf("%d Spacecraft ID", header.secondary.SpacecraftId);
   printf("     %d Virtual Stream ID",
                                     header.secondary.VirtualStreamId);
   printf("     %4.4x Error Flags\n", header.secondary.ErrorFlags);
   printf("%d Acquisition BET", header.secondary.AcquisitionBet);
   printf("    %d Maintenance BET", header.secondary.MaintenanceBet);
   printf("    %d Verify Count", header.secondary.VerifyCount);
   printf("    %d Flywheel Count\n", header.secondary.FlywheelCount);
   printf("%d Number of Received Bits",
                         header.secondary.NumberReceivedTelemetryBits);
   printf("    %d %d %d %d Number of Reed Solomon Error Symbols\n",
                                 header.secondary.RsSymbolErrorCount1,
                                 header.secondary.RsSymbolErrorCount2,
                                 header.secondary.RsSymbolErrorCount3,
                                 header.secondary.RsSymbolErrorCount4);
   printf("%2.2x Frame Sync Mode", header.secondary.FrameSyncMode);
   printf("    %2.2x Frame Sync Status", 
                                     header.secondary.FrameSyncStatus);
   printf("    %d Sync Bit Errors", header.secondary.SyncBitErrors);
   printf("    %c Freq Band\n", header.secondary.FrequencyBand);
   printf("%f Measured Bit Rate", header.secondary.MeasuredBitRate);
   printf("     %f System Noise Temperature\n",
                              header.secondary.SystemNoiseTemperature);
   printf("%f Symbol SNR ", header.secondary.SymbolSnr);
   printf("     %f Receiver Signal Level\n",
                                 header.secondary.ReceiverSignalLevel);
   printf("%d Master Antenna No.",
                                 header.secondary.MasterAntennaNumber);
   printf("    %d Master Receiver No.",
                                header.secondary.MasterReceiverNumber);
   printf("    %4.4x Lock Status\n",
                                 header.secondary.TelemetryLockStatus);
   printf("%d DTM Group No.", header.secondary.DtmGroupNumber);
   printf("     %d DTM Channel no.", header.secondary.DtmChannelNumber);
   printf("     %c%c DTM SoftwareIdentifier\n",
                            header.secondary.DtmSoftwareIdentifier[0],
                            header.secondary.DtmSoftwareIdentifier[1]);
}
