/* $Id: DumpTelemetryChdo.c,v 1.2 1998/02/20 15:34:43 rgr Exp $ */

/* $RCSfile: DumpTelemetryChdo.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/02/20 15:34:43 $ */
/* $Revision: 1.2 $ */

#include <sys/types.h>
#include <stdio.h>
#include "downlink/AceBlock.h"

#include "DumpClcw.h"
#include "DumpMinorFrameHeader.h"
#include "DumpPacketHeader.h"
#include "DumpVctfHeader.h"
#include "byteorder.h"

void DumpTelemetryChdo(TelemetryChdo *telemetry)
{
   static int msb0 = 0;
   static int msb1 = 0;
   static int msb2 = 0;
   static int msb3 = 0;
   int tmp;
   int i;
   u_char *TmpByte;

   if (msb0 == msb3) byteorder(&msb0, &msb1, &msb2, &msb3);
   TmpByte = (u_char *) &tmp;
   tmp = 0;

   printf("TELEMETRY CHDO - ");
   TmpByte[msb2] = telemetry->TypeAttribute[0];
   TmpByte[msb3] = telemetry->TypeAttribute[1];
   printf("    %u Type Attribute", tmp);
   TmpByte[msb2] = telemetry->LengthAttribute[0];
   TmpByte[msb3] = telemetry->LengthAttribute[1];
   printf("    %u Length Attribute", tmp);
   printf("    %2.2x%2.2x%2.2x%2.2x Sync\n", telemetry->sync[0],
                                             telemetry->sync[1],
                                             telemetry->sync[2],
                                             telemetry->sync[3]);
   DumpVctfHeader(telemetry->VctfHeader);
   DumpPacketHeader(telemetry->PacketHeader);
   DumpMinorFrameHeader(telemetry->MinorFrameHeader);
   printf("DATA ");
   for (i=0; i<842; i++) {
      if (i && (!(i % 4))) printf(" ");
      if (i && (!(i % 32))) printf("\n     ");
      printf("%2.2x", telemetry->data[i]);
   }
   printf("\nREED SOLOMON CODE");
   for (i=0; i<128; i++) {
      if (!(i % 4)) printf(" ");
      if (!(i % 32)) printf("\n     ");
      printf("%2.2x", telemetry->ReedSolomonCode[i]);
   }
   printf("\n");
   
   DumpClcw(telemetry->clcw);
}
