/* $Id: DumpVctfHeader.c,v 1.1 1998/01/26 06:26:32 rgr Exp $ */

/* $RCSfile: DumpVctfHeader.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/01/26 06:26:32 $ */
/* $Revision: 1.1 $ */

#include <sys/types.h>
#include <stdio.h>
#include "downlink/UnpackedVctfHeader.h"

#include "UnpackVctfHeader.h"

void DumpVctfHeader(u_char *VctfHeader)
{
   UnpackedVctfHeader header;

   UnpackVctfHeader(VctfHeader, &header);
   printf("VCTF HEADER - %u Transfer Frame Version Number",
                                    header.TransferFrameVersionNumber);
   printf("     %u Operational Control Field\n", 
                                       header.OperationalControlField);
   printf("%u Spacecraft ID", header.SpacecraftId);
   printf("     %u Virtual Channel ID\n", header.VirtualChannelId);
   printf("%u Transfer Frame Secondary Header Flag",
                              header.TransferFrameSecondaryHeaderFlag);
   printf("     %u Sync Flag", header.SyncFlag);
   printf("     %u Packet Order Flag\n", header.PacketOrderFlag);
   printf("%u Master Channel Frame Count",
                                       header.MasterChannelFrameCount);
   printf("     %u Virtual Channel Frame Count\n", 
                                      header.VirtualChannelFrameCount);
   if (header.VirtualChannelId == 2)
   {
      printf("%u SSR Operating Mode", header.SsrOperatingMode);
      printf("     %u SSR Read Pointer", header.SsrReadPointer);
      printf("     %u SSR ID\n", header.SsrId);
   }
   else
   {
      printf("%u Segment Length ID", header.SegmentLengthId);
      printf("     %u First Header Pointer\n",
                                            header.FirstHeaderPointer);
   }
}
