/* $Id: FillAceHeader.c,v 1.1 1998/02/20 15:11:55 rgr Exp $ */

/* $RCSfile: FillAceHeader.c,v $ */
/* $Author: rgr $ */
/* $Date: 1998/02/20 15:11:55 $ */
/* $Revision: 1.1 $ */

#include <sys/types.h>
#include "hdfi.h"

#include "AceConstants.h"
#include "AceTime.h"
#include "AceTime_yd.h"
#include "downlink/AceBlock.h"
#include "downlink/UnpackedPacketHeader.h"

#include "ace/AceEpochTime.h"
#include "ace/cvtFromSec1996.h"
#include "ace/cvtFromSec1996_yd.h"
#include "ace/cvtToSec1996.h"
#include "UnpackPacketHeader.h"

void FillAceHeader(AceBlock *block)
{
                 u_long centisecond;
                 u_long day;
                 u_long day1958;
                    int i;
                 u_long microsecond;
                 u_long millisecond;
   UnpackedPacketHeader PacketHeader;
                 u_long sec1996;
                 u_long Second1996;
         struct AceTime time;
      struct AceTime_yd time_yd;
                 u_long year;
       
   block->sync[0] = ACE_BLOCK_SYNC_BYTE0;
   block->sync[1] = ACE_BLOCK_SYNC_BYTE1;
   block->sync[2] = ACE_BLOCK_SYNC_BYTE2;
   block->sync[3] = ACE_BLOCK_SYNC_BYTE3;

   UnpackPacketHeader(block->telemetry.PacketHeader, &PacketHeader);
   AceEpochTime(PacketHeader.PacketSecondaryHeader,
                                            &Second1996, &microsecond);
   time = cvtFromSec1996(Second1996);
   millisecond = 1000*(3600L * time.hour + 60L * time.min + time.sec) +
                 microsecond/1000L;
   centisecond = millisecond/10;

   time.hour = 12L;
   time.min = 0L;
   time.sec = 0L;
   sec1996 = cvtToSec1996(time);
   time_yd = cvtFromSec1996_yd(sec1996);
   year = time_yd.year;
   day = (u_long) time_yd.day;

   day1958 = day + (13879 - 1);
   for (i=1996; i<year; i++) {
      day1958 += 365;
      if (!(i % 4)) day1958++;
   }

   block->DddHeader[4] = ACE_SPACECRAFT_ID;
   block->DddHeader[10] = (u_char) (day/100);
   block->DddHeader[11] = (u_char) (((day % 100)/10 << 4) + (day % 10));
   block->DddHeader[12] = (u_char) (centisecond >> 16);
   block->DddHeader[13] = (u_char) (centisecond >> 8);
   block->DddHeader[14] = (u_char) (centisecond & 0x000000ff);
   block->DddHeader[16] = (u_char) (16*(year/1000) + ((year/100) % 10));
   block->DddHeader[17] = (u_char) (16*((year/10) % 10) + (year % 10));

   block->HeaderAggregation[18] = ACE_SPACECRAFT_ID;
   block->HeaderAggregation[22] = (u_char) (day1958 >> 8);
   block->HeaderAggregation[23] = (u_char) (day1958 & 0x000000ff);
   block->HeaderAggregation[24] = (u_char) (millisecond >> 24);
   block->HeaderAggregation[25] = (u_char) (millisecond >> 16);
   block->HeaderAggregation[26] = (u_char) (millisecond >> 8);
   block->HeaderAggregation[27] = (u_char) (millisecond & 0x000000ff);
}
